Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3851)
@@ -271,4 +271,18 @@
       ctrl_out((/ 10, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     't2m_sic', "Temp 2m "//clnsurf(4), "K", (/ ('', i=1, 10) /)) /)
+
+  TYPE(ctrl_out), SAVE :: o_nt2mout = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nt2mout', 'Nbt2m out of range complete computation', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_nq2mout = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nq2mout', 'Nbq2m out of range complete computation', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_nu2mout = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nu2mout', 'Nbu2m out of range complete computation', '-', (/ ('', i=1, 10) /))
+
+  TYPE(ctrl_out), SAVE :: o_nt2moutfg = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nt2moutfg', 'Nbt2m out of range complete/fgRi1 computation', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_nq2moutfg = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nq2moutfg', 'Nbq2m out of range complete/fgRi1 computation', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_nu2moutfg = ctrl_out((/ 1, 1, 1, 5, 10, 10, 11, 11, 11, 11/), &
+    'nu2moutfg', 'Nbu2m out of range complete/fgRi1 computation', '-', (/ ('', i=1, 10) /))
 
   TYPE(ctrl_out), SAVE :: o_gusts = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11, 11/), &
@@ -461,5 +475,7 @@
   TYPE(ctrl_out), SAVE :: o_SWupSFCcleanclr = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
     'SWupSFCcleanclr', 'SWup clear sky clean (no aerosol) at surface', 'W/m2', (/ ('', i=1, 10) /))
-  TYPE(ctrl_out), SAVE :: o_SWdnSFC = ctrl_out((/ 1, 1, 10, 10, 5, 10, 11, 11, 11, 11/), &
+  TYPE(ctrl_out), SAVE :: o_fdiffSWdnSFC = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'fdiffSWdnSFC', 'Fraction of diffuse SWdn at surface', 'W/m2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_SWdnSFC = ctrl_out((/ 1, 1, 1, 10, 5, 10, 11, 11, 11, 11/), &
     'SWdnSFC', 'SWdn at surface', 'W/m2', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_SWdnSFCclr = ctrl_out((/ 1, 4, 10, 10, 5, 10, 11, 11, 11, 11/), &
@@ -694,15 +710,15 @@
     'iwp', 'Cloud ice water path', 'kg/m2', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_ue = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'ue', 'Zonal dry static energy transport', '-', (/ ('', i=1, 10) /))
+    'ue', 'Zonal dry static energy transport', 'J/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_ve = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    've', 'Merid dry static energy transport', '-', (/ ('', i=1, 10) /))
+    've', 'Merid dry static energy transport', 'J/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_uq = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'uq', 'Zonal humidity transport', '-', (/ ('', i=1, 10) /))
+    'uq', 'Zonal humidity transport', 'kg/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_vq = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'vq', 'Merid humidity transport', '-', (/ ('', i=1, 10) /))
+    'vq', 'Merid humidity transport', 'kg/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_uwat = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'uwat', 'Zonal total water transport', '-', (/ ('', i=1, 10) /))
+    'uwat', 'Zonal total water transport', 'kg/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_vwat = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'vwat', 'Merid total water transport', '-', (/ ('', i=1, 10) /))
+    'vwat', 'Merid total water transport', 'kg/m/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_cape = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'cape', 'Conv avlbl pot ener', 'J/kg', (/ ('', i=1, 10) /))
@@ -1003,9 +1019,10 @@
   TYPE(ctrl_out), SAVE :: o_tke = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke ', 'TKE', 'm2/s2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_tke_dissip = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'tke_dissip ', 'TKE DISSIPATION', 'm2/s3', (/ ('', i=1, 10) /))   
   TYPE(ctrl_out), SAVE :: o_tke_max = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke_max', 'TKE max', 'm2/s2',                                  &
       (/ 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', &
          't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)', 't_max(X)' /))
-
   TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_tke_srf      = (/             &
       ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'tke_ter',       &
@@ -1048,4 +1065,5 @@
       ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/),'l_mix_sic',       &
       "min PBL mixing length "//clnsurf(4),"m", (/ ('', i=1, 10) /)) /)
+
 
   TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_tke_max_srf  = (/                          &
@@ -1432,4 +1450,8 @@
   TYPE(ctrl_out), SAVE :: o_rhum = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'rhum', 'Relative humidity', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_rhl = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'rhl', 'Relative humidity wrt liquid', '%', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_rhi = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'rhi', 'Relative humidity wrt ice', '%', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_ozone = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'ozone', 'Ozone mole fraction', '-', (/ ('', i=1, 10) /))
@@ -1946,3 +1968,43 @@
 #endif
 
+   type(ctrl_out), save:: o_delta_sst &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'delta_SST', &
+        "ocean-air interface temperature minus bulk SST", "K", '')
+
+   type(ctrl_out), save:: o_delta_sal &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'delta_sal', &
+        "ocean-air interface salinity minus bulk salinity", "ppt", '')
+
+   type(ctrl_out), save:: o_ds_ns &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'dS_ns', &
+        "subskin salinity minus foundation salinity", "ppt", '')
+
+   type(ctrl_out), save:: o_dt_ns &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'dT_ns', &
+        "subskin temperature minus foundation temperature", "K", '')
+
+   type(ctrl_out), save:: o_dter &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'dTer', &
+        "ocean-air interface temperature minus sub-skin temperature", "K", '')
+
+   type(ctrl_out), save:: o_dser &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'dSer', &
+        "ocean-air interface salinity minus sub-skin salinity", "ppt", '')
+
+   type(ctrl_out), save:: o_tkt &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'tkt', &
+        "thickness of thermal microlayer", "m", '')
+
+   type(ctrl_out), save:: o_tks &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'tks', &
+        "thickness of salinity microlayer", "m", '')
+
+   type(ctrl_out), save:: o_taur &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'taur', &
+        "momentum flux due to rain", "Pa", '')
+
+   type(ctrl_out), save:: o_sss &
+        = ctrl_out([1, 10, 10, 1, 10, 10, 11, 11, 11, 11], 'SSS', &
+        "bulk sea-surface salinity", "ppt", '')
+
 END MODULE phys_output_ctrlout_mod
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_mod.F90	(revision 3851)
@@ -40,5 +40,5 @@
     USE mod_phys_lmdz_para
     !Martin
-    USE surface_data, ONLY : ok_snow
+    USE surface_data, ONLY : landice_opt
     USE phys_output_ctrlout_mod
     USE mod_grid_phy_lmdz, only: klon_glo,nbp_lon,nbp_lat
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_var_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_var_mod.F90	(revision 3851)
@@ -133,4 +133,28 @@
  !$OMP THREADPRIVATE(sens_prec_liq_o, sens_prec_sol_o,lat_prec_liq_o,lat_prec_sol_o)
 
+  ! Ocean-atmosphere interface, subskin ocean and near-surface ocean:
+  
+  REAL, ALLOCATABLE, SAVE:: dter(:)
+  ! Temperature variation in the diffusive microlayer, that is
+  ! ocean-air interface temperature minus subskin temperature. In K.
+      
+  REAL, SAVE, ALLOCATABLE:: dser(:)
+  ! Temperature variation in the diffusive microlayer, that is
+  ! subskin temperature minus ocean-air interface temperature. In K.
+
+  REAL, SAVE, ALLOCATABLE:: tkt(:)
+  ! épaisseur (m) de la couche de diffusion thermique (microlayer)
+  ! cool skin thickness
+
+  REAL, SAVE, ALLOCATABLE:: tks(:)
+  ! épaisseur (m) de la couche de diffusion de masse (microlayer)
+  
+  REAL, SAVE, ALLOCATABLE:: taur(:) ! momentum flux due to rain, in Pa
+
+  REAL, SAVE, ALLOCATABLE:: sss(:)
+  ! bulk salinity of the surface layer of the ocean, in ppt
+  
+  !$OMP THREADPRIVATE(dter, dser, tkt, tks, taur, sss)
+
 CONTAINS
 
@@ -138,4 +162,5 @@
   SUBROUTINE phys_output_var_init
     use dimphy
+    use config_ocean_skin_m, only: activate_ocean_skin
 
     IMPLICIT NONE
@@ -191,4 +216,7 @@
     IF (ok_gwd_rando) allocate(zustr_gwd_rando(klon), zvstr_gwd_rando(klon))
 
+    if (activate_ocean_skin >= 1) allocate(dter(klon), dser(klon), tkt(klon), &
+         tks(klon), taur(klon), sss(klon))
+
   END SUBROUTINE phys_output_var_init
 
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_write_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/phys_output_write_mod.F90	(revision 3851)
@@ -38,4 +38,7 @@
          o_t2m, o_t2m_min, o_t2m_max, &
          o_t2m_min_mon, o_t2m_max_mon, &
+         o_nt2mout, o_nt2moutfg, &
+         o_nq2mout, o_nq2moutfg, &
+         o_nu2mout, o_nu2moutfg, &
          o_q2m, o_ustar, o_u10m, o_v10m, &
          o_wind10m, o_wind10max, o_wind100m, o_gusts, o_sicf, &
@@ -45,5 +48,5 @@
          o_snow, o_msnow, o_fsnow, o_evap, o_ep,o_epmax_diag, & ! epmax_cape
          o_tops, o_tops0, o_topl, o_topl0, &
-         o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, &
+         o_SWupTOA, o_SWupTOAclr, o_SWupTOAcleanclr, o_SWdnTOA, o_fdiffSWdnSFC, &
          o_SWdnTOAclr, o_nettop, o_SWup200, &
          o_SWup200clr, o_SWdn200, o_SWdn200clr, &
@@ -133,8 +136,8 @@
          o_vitu, o_vitv, o_vitw, o_pres, o_paprs, &
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
-         o_rnebls, o_rneblsvol, o_rhum, o_ozone, o_ozone_light, &
+         o_rnebls, o_rneblsvol, o_rhum, o_rhl, o_rhi, o_ozone, o_ozone_light, &
          o_duphy, o_dtphy, o_dqphy, o_dqphy2d, o_dqlphy, o_dqlphy2d, &
          o_dqsphy, o_dqsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
-         o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, &
+         o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, o_tke_dissip, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
          o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
@@ -199,6 +202,7 @@
          o_col_O3_strato, o_col_O3_tropo,                 & 
 !--interactive CO2
-         o_flx_co2_ocean, o_flx_co2_land, o_flx_co2_ff, o_flx_co2_bb
-
+         o_flx_co2_ocean, o_flx_co2_land, o_flx_co2_ff, o_flx_co2_bb, &
+         o_delta_sst, o_delta_sal, o_ds_ns, o_dt_ns, o_dter, o_dser, o_tkt, &
+         o_tks, o_taur, o_sss
 
 #ifdef CPP_StratAer
@@ -223,5 +227,5 @@
          qsol, z0m, z0h, fevap, agesno, &
          nday_rain, rain_con, snow_con, &
-         topsw, toplw, toplw0, swup, swdn, &
+         topsw, toplw, toplw0, swup, swdn, solswfdiff, &
          topsw0, swupc0, swdnc0, swup0, swdn0, SWup200, SWup200clr, &
          SWdn200, SWdn200clr, LWup200, LWup200clr, &
@@ -245,11 +249,11 @@
          T2sumSTD, nlevSTD, du_gwd_rando, du_gwd_front, &
          ulevSTD, vlevSTD, wlevSTD, philevSTD, qlevSTD, tlevSTD, &
-         rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, &
-         vphiSTD, wTSTD, u2STD, v2STD, T2STD, missing_val_nf90
+         rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, vphiSTD, &
+         wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
+         dt_ns, delta_sst
 
     USE phys_local_var_mod, ONLY: zxfluxlat, slp, ptstar, pt0, zxtsol, zt2m, &
-         zt2m_cor,zq2m_cor,zu10m_cor,zv10m_cor, zrh2m_cor, zqsat2m_cor, &
-         t2m_min_mon, t2m_max_mon, evap, &
-         l_mixmin,l_mix, &
+         zn2mout, t2m_min_mon, t2m_max_mon, evap, &
+         l_mixmin,l_mix, tke_dissip, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
          rain_lsc, rain_num, snow_lsc, bils, sens, fder, &
@@ -258,8 +262,8 @@
          sissnow, runoff, albsol3_lic, evap_pot, &
          t2m, fluxt, fluxlat, fsollw, fsolsw, &
-         wfbils, wfbilo, wfevap, wfrain, wfsnow, & 
+         wfbils, wfbilo, wfevap, wfrain, wfsnow, &
          cdragm, cdragh, cldl, cldm, &
-         cldh, cldt, JrNt, cldljn, cldmjn, cldhjn, &
-         cldtjn, cldq, flwp, fiwp, ue, ve, uq, vq, &
+         cldh, cldt, JrNt,   & ! only output names: cldljn,cldmjn,cldhjn,cldtjn
+         cldq, flwp, fiwp, ue, ve, uq, vq, &
          uwat, vwat, &
          plcl, plfc, wbeff, convoccur, upwd, dnwd, dnwd0, prw, prlw, prsw, &
@@ -297,5 +301,5 @@
          ql_seri, qs_seri, tr_seri, &
          zphi, u_seri, v_seri, omega, cldfra, &
-         rneb, rnebjn, rneblsvol, zx_rh, d_t_dyn,  & 
+         rneb, rnebjn, rneblsvol, zx_rh, zx_rhl, zx_rhi, d_t_dyn,  & 
          d_q_dyn,  d_ql_dyn, d_qs_dyn, &
          d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, &
@@ -353,5 +357,5 @@
          alt_tropo, &
 !Ionela
-         ok_4xCO2atm
+         ok_4xCO2atm, dter, dser, tkt, tks, taur, sss
 
     USE ocean_slab_mod, ONLY: nslay, tslab, slab_bilg, tice, seaice, &
@@ -361,5 +365,5 @@
     USE infotrac_phy, ONLY: nqtot, nqo, type_trac, tname, niadv
     USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
-    USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, ok_snow
+    USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
     USE aero_mod, ONLY: naero_tot, id_STRAT_phy
     USE ioipsl, ONLY: histend, histsync
@@ -380,4 +384,5 @@
 #endif
     USE tracinca_mod, ONLY: config_inca
+    use config_ocean_skin_m, only: activate_ocean_skin
 
     USE vertical_layers_mod, ONLY: presnivs
@@ -458,4 +463,8 @@
 #ifdef CPP_XIOS
     CALL wxios_set_context
+#endif
+
+#ifndef CPP_XIOS
+    missing_val=missing_val_nf90
 #endif
 
@@ -676,7 +685,7 @@
        CALL histwrite_phy(o_slp, slp)
        CALL histwrite_phy(o_tsol, zxtsol)
-       CALL histwrite_phy(o_t2m, zt2m_cor)
-       CALL histwrite_phy(o_t2m_min, zt2m_cor)
-       CALL histwrite_phy(o_t2m_max, zt2m_cor)
+       CALL histwrite_phy(o_t2m, zt2m)
+       CALL histwrite_phy(o_t2m_min, zt2m)
+       CALL histwrite_phy(o_t2m_max, zt2m)
        CALL histwrite_phy(o_t2m_max_mon, t2m_max_mon)
        CALL histwrite_phy(o_t2m_min_mon, t2m_min_mon)
@@ -684,5 +693,47 @@
        IF (vars_defined) THEN
           DO i=1, klon
-             zx_tmp_fi2d(i)=SQRT(zu10m_cor(i)*zu10m_cor(i)+zv10m_cor(i)*zv10m_cor(i))
+             zx_tmp_fi2d(i)=real(zn2mout(i,1))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nt2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,2))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nt2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,3))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nq2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,4))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nq2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,5))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nu2mout, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=real(zn2mout(i,6))
+          ENDDO
+       ENDIF
+       CALL histwrite_phy(o_nu2moutfg, zx_tmp_fi2d)
+
+       IF (vars_defined) THEN
+          DO i=1, klon
+             zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
           ENDDO
        ENDIF
@@ -691,5 +742,5 @@
        IF (vars_defined) THEN
           DO i=1, klon
-             zx_tmp_fi2d(i)=SQRT(zu10m_cor(i)*zu10m_cor(i)+zv10m_cor(i)*zv10m_cor(i))
+             zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
           ENDDO
        ENDIF
@@ -699,5 +750,4 @@
 
        IF (vars_defined) THEN
-          missing_val=missing_val_nf90
           DO k = 1, kmax_100m                                      !--we could stop much lower
             zrho(:) = pplay(:,k)/t_seri(:,k)/RD                    ! air density in kg/m3
@@ -771,8 +821,9 @@
        ENDIF
        CALL histwrite_phy(o_sicf, zx_tmp_fi2d)
-       CALL histwrite_phy(o_q2m, zq2m_cor)
-       CALL histwrite_phy(o_ustar, zustar)
-       CALL histwrite_phy(o_u10m, zu10m_cor)
-       CALL histwrite_phy(o_v10m, zv10m_cor)
+       CALL histwrite_phy(o_q2m, zq2m)
+       IF (vars_defined) zx_tmp_fi2d = zustar
+       CALL histwrite_phy(o_ustar, zx_tmp_fi2d)
+       CALL histwrite_phy(o_u10m, zu10m)
+       CALL histwrite_phy(o_v10m, zv10m)
 
        IF (vars_defined) THEN
@@ -935,4 +986,6 @@
        ENDIF
        CALL histwrite_phy(o_SWdnSFCcleanclr, zx_tmp_fi2d)
+
+       CALL histwrite_phy(o_fdiffSWdnSFC, solswfdiff)
 
        IF (vars_defined) THEN
@@ -996,5 +1049,5 @@
        CALL histwrite_phy(o_tauy, zx_tmp_fi2d)
 
-       IF (ok_snow) THEN
+       IF (landice_opt .GE. 1) THEN
           CALL histwrite_phy(o_snowsrf, snow_o)
           CALL histwrite_phy(o_qsnow, qsnow)
@@ -1054,4 +1107,6 @@
              CALL histwrite_phy(o_l_mixmin(nsrf),  l_mixmin(:,1:klev,nsrf))
              CALL histwrite_phy(o_tke_max_srf(nsrf),  pbl_tke(:,1:klev,nsrf))
+
+                         
           ENDIF
 !jyg<
@@ -1064,6 +1119,20 @@
 !            ENDIF
 
-
        ENDDO
+       
+                
+        IF (iflag_pbl > 1) THEN
+          zx_tmp_fi3d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                DO k=1,klev
+                   zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k) &
+                        +pctsrf(:,nsrf)*tke_dissip(:,k,nsrf)
+                ENDDO
+             ENDDO
+          ENDIF
+          
+          CALL histwrite_phy(o_tke_dissip, zx_tmp_fi3d)    
+       ENDIF
 
        IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_liq_o(1 : klon, 1)
@@ -1189,5 +1258,4 @@
        ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
        ! Champs interpolles sur des niveaux de pression
-       missing_val=missing_val_nf90
        DO iff=1, nfiles
           ll=0
@@ -1412,5 +1480,5 @@
 !       CALL histwrite_phy(o_rh2m_max, zx_tmp_fi2d)
 
-       CALL histwrite_phy(o_qsat2m, zqsat2m_cor)
+       CALL histwrite_phy(o_qsat2m, qsat2m)
        CALL histwrite_phy(o_tpot, tpot)
        CALL histwrite_phy(o_tpote, tpote)
@@ -1691,4 +1759,11 @@
        CALL histwrite_phy(o_rnebjn, zx_tmp_fi3d)
        CALL histwrite_phy(o_rhum, zx_rh)
+       IF (iflag_ice_thermo .GT. 0) THEN
+          IF (vars_defined) zx_tmp_fi3d = zx_rhl * 100.
+          CALL histwrite_phy(o_rhl, zx_tmp_fi3d)
+          IF (vars_defined) zx_tmp_fi3d = zx_rhi * 100.
+          CALL histwrite_phy(o_rhi, zx_tmp_fi3d)
+       ENDIF
+
        
        IF (vars_defined) zx_tmp_fi3d = wo(:, :, 1) * dobson_u * 1e3 / zmasse / rmo3 * rmd
@@ -1749,6 +1824,6 @@
           ENDIF
           CALL histwrite_phy(o_tke, zx_tmp_fi3d)
-
-          CALL histwrite_phy(o_tke_max, zx_tmp_fi3d)
+          CALL histwrite_phy(o_tke_max, zx_tmp_fi3d)  
+
        ENDIF
 
@@ -2168,5 +2243,4 @@
        ! ATTENTION, LES ANCIENS HISTWRITE ONT ETES CONSERVES EN ATTENDANT MIEUX:
        ! Champs interpolles sur des niveaux de pression
-       missing_val=missing_val_nf90
        DO iff=7, nfiles-1 !--OB: here we deal with files 7,8,9
 
@@ -2359,4 +2433,17 @@
        ENDIF   !(iflag_phytrac==1)
 
+       if (activate_ocean_skin >= 1) then
+          CALL histwrite_phy(o_delta_sst, delta_sst)
+          CALL histwrite_phy(o_delta_sal, delta_sal)
+          CALL histwrite_phy(o_ds_ns, ds_ns)
+          CALL histwrite_phy(o_dt_ns, dt_ns)
+          CALL histwrite_phy(o_dter, dter)
+          CALL histwrite_phy(o_dser, dser)
+          CALL histwrite_phy(o_tkt, tkt)
+          CALL histwrite_phy(o_tks, tks)
+          CALL histwrite_phy(o_taur, taur)
+          CALL histwrite_phy(o_sss, sss)
+       end if
+
        IF (.NOT.vars_defined) THEN
           !$OMP MASTER
